<?php

  //////////////////////////////////////////////////////////////////
  // Orbit SecureMyEmail                                          //
  // -------------------                                          //
  //                                                              //
  // Orbit SecureMyEmail was solely written and developed         //
  // by Orbit Services                                            //
  // http://www.orbitservices.net                                 //
  //                                                              //
  // version: 1.0                                                 //
  //                                                              //
  //////////////////////////////////////////////////////////////////

  /*

   Introduction
   ------------

   The concept of this project is simple, we want to hide your actual
   email address from those nasty spammers while still allowing your
   website users the ability to directly email you from their default
   email clients.

   Strategy
   --------

   We use a unique @ and . replacement to ensure the bad guys cant guess
   your email (e.g. they now no that [at] is a common replacement) and
   then use a popup window to prompt the user for captcha details. Then
   the script will be used to then convert your email address to the real
   value and then use php to call the mailto function, therefore avoiding
   any record of the email address in the web browser.

   GNU License Agreement
   ---------------------

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

   > copyright Copyright: 2007 Orbit Services
   > author Chris Winfield-Blum
   > package Orbit SecureMyEmail

   What Can You Do To Help?
   ------------------------

   You can of course use and share this script with as many people as
   possible. You can also contribute ideas and code to the project.

   The primary forum can be found here for support, contributions etc:
   http://forums.orbitservices.net/index.php?c=5

   If you use this script I would appreciate if you would let me know
   through the testimonials forum:
   http://forums.orbitservices.net/viewforum.php?f=15


   Known Issues and Ideas
   ----------------------

   Currently their is an issue with IE that the popup window will not
   automatically close. This doesnt effect our security but will
   be something I would look to improve in the future.


   Usage
   -----

   <?php
   require('OrbitSecureMyEmail.php');
   ?>

   <script type="text/javascript">
   <!--
   function myEmailPopup(url) {
    window.open( url, "myWindow","status = 0, height = 200, width = 400, resizable = 0" )
   }
   //-->
   </script>

   <?php

   echo BuildMySecureEmail('user@domain.com', $at, $script_name, $message);

   // OR //

   $myemail = BuildMySecureEmail('user@domain.com', $at, $script_name, $message);
   echo $myemail;

   // OR //

   echo BuildMySecureEmail('user@domain.com', $at, 'http://www.domain.com/inc/OrbitSecureMyEmail.php', 'email me here!!');

   ?>

  */


  //  Settings  //

      // Sometimes we have problems with session warnings
      // so lets set the ini to hide them
      ini_set ( "display_errors", "~E_ALL" );

      // Start our session
      session_start();

      // Set the absolute path to our class e.g. http://www.domain.com/incs/OrbitSecureMyEmail.php
      // This is used for the popup window to be loaded.
      // You can either place this here or enter it directly into the function
      $script_name = 'http://www.domain.com/orbitsme/OrbitSecureMyEmail.php';

      // Set your message to be printed to the browser
      // You can either place this here or enter it directly into the function
      $message = 'email me here';

      // Set your unique @ replacement
      $at = '_123456_at_654321_';

      // Set your unique . replacement
      $dot = '_123456_dot_654321_';

      // Set your messages to be printed to the browser during CAPTCHA
      $captcha_message = 'Sorry but I just want to make sure you are not a robot, please enter the text in the message below';
      $captcha_sorry_message = 'Sorry but you have not entered the correct information, please try again...<BR><a href="#" onclick="self.close();">close window</a>';

      // Use GD Library to dynamically build images (1: Yes)(0: No)
      $use_gd_lib = 1;

      // Set the absolute path to our Captcha Calss e.g. http://www.domain.com/incs/CaptchaSecurityImages.php
      $captcha_script = 'http://www.domain.com/orbitsme/CaptchaSecurityImages.php';

      // Set your captcha image path ~ without /
      // This can be a url e.g. http://www.domain.com/images
      // or relative path to our scripts
      // This is used if use_gd_lib = 0
      $captcha_imagepath = 'captcha';


  /*
     ----------------------
     DO NOT EDIT BELOW HERE
     ----------------------
  */

  // Footer for our popups
  // Please respect the work I have done and leave this here
  //$osme_footer = "<div style='position: absolute; right: 4px; bottom: 2px; width: 350px; text-align: right;'><a href='http://www.orbitservices.net' target='_blank'><font face='verdana' size='1'>my email is protected by Orbit Secure-My-Email</font></a></div>";
  $osme_footer = "<div style='position: absolute; right: 4px; bottom: 2px; width: 350px; text-align: right;'><a href='http://www.orbitservices.net' target='_blank'><img src=\"http://www.orbitservices.net/orbitsme/orbitsme_logo.php\" title='my email is protected by Orbit Secure-My-Email' alt='my email is protected by Orbit Secure-My-Email' border='0'></a></div>";

  // Get our email address
  $osme = $_GET['osme'];

  // If GD Library is not being used then use our array
  if($use_gd_lib != '1')
    {
      // Build Our Captcha Array - you may add your own images here too
      $captcha[] = array('ourfile' => '01.jpg', 'answer' => '5n25g8');
      $captcha[] = array('ourfile' => '02.jpg', 'answer' => 'nk7tkt');
      $captcha[] = array('ourfile' => '01.jpg', 'answer' => '5n25g8');
      $captcha[] = array('ourfile' => '03.jpg', 'answer' => '3hdcfv');
      $captcha[] = array('ourfile' => '04.jpg', 'answer' => '7s5qk8');
      $captcha[] = array('ourfile' => '05.jpg', 'answer' => '4fj8k8');
      $captcha[] = array('ourfile' => '06.jpg', 'answer' => '3fdfg2');
      $captcha[] = array('ourfile' => '07.jpg', 'answer' => 'gks8wh');
      $captcha[] = array('ourfile' => '08.jpg', 'answer' => 'ygs2cc');
      $captcha[] = array('ourfile' => '09.jpg', 'answer' => 'fchst3');
      $captcha[] = array('ourfile' => '10.jpg', 'answer' => 'kpr2j8');
  }

  // Function to Build the Secure Email and Link.
  function BuildMySecureEmail($email, $at, $dot, $script, $message)
    {
      // Get our real email and replace our @
      $email = str_replace ( "@", "$at", $email );
      $email = str_replace ( ".", "$dot", $email );

      // Define the browser output
      $secure_email = "<a href=\"#\" onClick=\"myEmailPopup('$script?osme=$email')\">$message</a><!-- Thank Goodness!! My Email Was Secured by Orbit SecureMyEmail http://www.orbitservices.net -->";

      // Return the new secure email address
      return $secure_email;
    }

  // Function to Decrypt our secure email.
  function LoadMySecureEmail($email, $at, $dot)
    {
      // Grab our secure email and replace OUR at with the real @
      $email = str_replace ( "$at", "@", $email );
      $email = str_replace ( "$dot", ".", $email );

      // Return the real email to php
      return $email;
    }

  // If osme is available we know this is our popup
  if($osme != '')
    {

      // If our information is submitted then we run our checks.
      if(($_POST[captcha_answer] != '')AND($use_gd_lib == '1'))
        {
          // Get the Captcha answer from the session
          $captcha_real_answer = $_SESSION['security_code'];

          // Get the users answer
          $captcha_post_answer = $_POST['captcha_answer'];

          // if array and posted answer is the same then we will trigger our
          // mailto
          if($captcha_real_answer == $captcha_post_answer)
            {
                // get the REAL email
                $osme = LoadMySecureEmail($osme, $at, $dot);

                // trigger our mailto without publishing to the browser the email
                header("Location: mailto:$osme");

                // lets try autoclose our window
                echo "<script>this.focus(); self.opener = this; self.close();</script>";
                echo '<a href="#" onclick="self.close();">close window</a>';

                // exit our script
                exit;
            }
          // if the answers dont match the let the user know
          else
            {

              echo "<font face='verdana' size='2'>$captcha_sorry_message<BR><BR>";
              echo $osme_footer;
              exit;

            }
        }
      else if(($_POST[captcha_answer] != '')AND($use_gd_lib != '1'))
        {
          // If our information is submitted then we run our checks.
          if(($_POST[captcha_id] != '')AND($_POST[captcha_answer] != ''))
            {
              // Get the Captcha ID which is our array key
              $captcha_post_id = $_POST[captcha_id];

              // Get the users answer
              $captcha_post_answer = $_POST[captcha_answer];

              // Get the actual answer from our array
              $array_answer = $captcha[$captcha_post_id][answer];

              // if array and posted answer is the same then we will trigger our
              // mailto
              if($array_answer == $captcha_post_answer)
                {
                    // get the REAL email
                    $osme = LoadMySecureEmail($osme, $at, $dot);

                    // trigger our mailto without publishing to the browser the email
                    header("Location: mailto:$osme");

                    // lets try autoclose our window
                    echo "<script>this.focus(); self.opener = this; self.close();</script>";
                    echo '<a href="#" onclick="self.close();">close window</a>';

                    // exit our script
                    exit;
                }
              // if the answers dont match the let the user know
              else
                {

                  echo "<font face='verdana' size='2'>$captcha_sorry_message<BR><BR>";
                  echo $osme_footer;
                  exit;

                }

            }
          else if(($_POST[captcha_id] != '')AND($_POST[captcha_answer] == ''))
            {
                  echo "<font face='verdana' size='2'>$captcha_sorry_message<BR><BR>";
                  echo $osme_footer;
                  exit;
            }
        }

        // If GD Library is not being used then use our array functions
        if($use_gd_lib != '1')
          {

            // Get our random captcha record from the array
            $rand_captcha = array_rand($captcha);

            // Set our Captcha ID
            $captcha_id = $rand_captcha;

            // Get our image filename from the array
            $captcha_ourfile = $captcha[$rand_captcha][ourfile];

          }

        // Output our form with captcha image and form fields
        // the Captcha ID is stored in a hidden field for future use
        ?>
        <font face='verdana' size='2'><?=$captcha_message;?><BR><BR>
        <form ACTION="<?=$PHP_SELF;?>?osme=<?=$osme;?>" METHOD="POST" NAME="captcha_form">
        <?php
          if($use_gd_lib == '1')
            {
        ?>
        <img src="<?=$captcha_script;?>?width=100&height=40&characters=5" />
        <?php
            }
          else if($use_gd_lib == '0')
            {
        ?>
        <img src='<?=$captcha_imagepath;?>/<?=$captcha_ourfile;?>'><INPUT TYPE="hidden" NAME="captcha_id" value="<?=$captcha_id;?>"><BR><BR>
        <?php
            }
        ?>
        <BR><BR>
        Please enter the text in the image<BR>
        <INPUT TYPE="text" NAME="captcha_answer" MAXLENGTH=10 value=""><INPUT TYPE="submit" VALUE="confirm">
        <form>
        <?=$osme_footer;?>
        </font>
        <?php

    }

  ?>